﻿namespace PostponableActionDemo
{
    using System;
    using SystemHelpers;

    public class TestObject
    {
        public TestObject()
        {
            this._postponableSort = new PostponableAction(this.SortImplementation);
        }

        #region Postponable Sort

        private PostponableAction _postponableSort;

        private void SortImplementation()
        {
            ConsoleColor oldColor = Console.ForegroundColor;
            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine("Sort > sorting ...");
            Console.ForegroundColor = oldColor;
        }

        public void Sort()
        {
            this._postponableSort.Execute();
        }

        public IDisposable PostponeSort()
        {
            return this._postponableSort.PostponeAction();
        }

        #endregion

        public void Operation1()
        {
            // Do something ...
            Console.WriteLine("Operation1");

            this.Sort();
        }

        public void Operation2()
        {
            // Do something ...
            Console.WriteLine("Operation2");

            this.Sort();
        }

        public void Operation3()
        {
            Console.WriteLine("Operation3 > starting ... ");

            using (this.PostponeSort()) {
                this.Operation1();
                this.Operation2();
            }

            Console.WriteLine("Operation3 > completed.");
        }
    }
}
